/**************************************************************

   Program Title:  GenY32 GRBL Port
   
   Program Name:  nvram.h	 Version: 1.00
   
   Author:  ALD	  					  Date:  May 11, 2014
   
   Compiled with AVR Studio 6.1.2730
   
   This file contains routines that implement non-volatile storage
   using the last 4KB of on-chip flash.
   
   Atmel ASF drivers are used for lower layers.
   
   Copyright 2014, Tony da Costa  All rights reserved.
   
****************************************************************/
/*
 * Copyright 2014, Tony da Costa  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the copyright holders nor the names of
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TONY DA COSTA AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SOC ROBOTICS, 
 * INC. OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/*
 * nvram.h
 *
 * Created: 10/05/2014 8:47:18 PM
 *  Author: tdacosta
 */ 


#ifndef NVRAM_H_
#define NVRAM_H_

#define NVRAM_SIZE 4096

#define NVRAM_ADDR_VERSION 0
#define NVRAM_ADDR_GLOBAL 1
#define NVRAM_ADDR_PARAMETERS 512
#define NVRAM_ADDR_STARTUP_BLOCK 768

BOOL nvram_Init(void);
BOOL nvram_Read(uint16_t address, uint8_t *destPtr, uint16_t size);
BOOL nvram_Write(uint16_t address, uint8_t *srcPtr, uint16_t size);
BOOL nvram_ReadWithChecksum(uint16_t address, uint8_t *destPtr, uint16_t size);
BOOL nvram_WriteWithChecksum(uint16_t address, uint8_t *srcPtr, uint16_t size);

#endif /* NVRAM_H_ */